/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.3 $
* Date:         $Date: 2009/06/30 03:23:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"
#ifdef BOARD_A5
#include <asm/io.h>
#endif
/*#include "mttypes.h"
#include "awardm.h"
#include "mterror.h"*/

//#include <asm/rtl865x/rtl865xc_asicregs.h>
//Joseph  test
#include "../../char/ralink_gpio.h"
//#include <ralink_gpio.h>
// 



#define DELAY 3000

#ifdef BOARD_A3
#define SETRDYPIN() set_rdy_pin()
#define default_gpio() default_gpio_a3()

#elif defined (BOARD_A2)
#define SETRDYPIN() 
#define default_gpio() default_gpio_a2()

#else
#define SETRDYPIN() 
#define default_gpio()

#endif

#ifdef __KERNEL__
//semaphore used to control hpi r/w throhgh IOCTL
//static DECLARE_MUTEX(mr_sem);
//spinlock_t mr_lock = SPIN_LOCK_UNLOCKED;
#endif


void set_resp_rdy_to_input(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_en = (mt_uint32*) GPIO_EN;
	volatile mt_uint32* p_gpio_ben = (mt_uint32*) GPIO_BEN;
	volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	*p_gpio_ben |= RESP_RDY_BIT;
	*p_gpio_en |= RESP_RDY_BIT;
	*p_gpio_dir = (*p_gpio_dir & ~RESP_RDY_BIT);
#else
#endif
}


mt_uint32 reset_chip(mt_uint32 chipid)
{
#ifdef AWARD	
	mt_uint32 i;
	//volatile mt_uint32* p_gpio_en = (mt_uint32*) GPIO_EN;
	//volatile mt_uint32* p_gpio_ben = (mt_uint32*) GPIO_BEN;
	//volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	volatile mt_uint32* p_gpio_data = (mt_uint32*) GPIO_DATA;

	// Award modem holds only one Falcon chip
	if(chipid > MT_PORT_BroadCast)
		return MT_NO_SUCH_CHIP;

	port_info[chipid].status = MT_OPSTATE_DISABLE;

	// Set the boot mode and activate reset
	// RST_N is active low
	*p_gpio_data = (*p_gpio_data & ~FALCON_MASK) | BOOT_MODE;
	//PRINTL(DBG_LVL_LIB,"reset_chip:FALCON_MASK=%x,GPIO_DATA=%08x.\n", FALCON_MASK,p_gpio_data);
	printk("reset_chip:FALCON_MASK=%x,GPIO_DATA=%08x.\n", FALCON_MASK,p_gpio_data);
	//*p_gpio_data &= ~0x00000800 ;
       
	//PRINTD("TestGPIO:in2\n");

	//*p_gpio_en |= 0x00000800  ;
	//*p_gpio_dir |= 0x00000800 ; 
	//*p_gpio_ben |= 0x00000800 ;
	//*p_gpio_data &= ~0x00000800 ;
	
	for(i=0;i<300;i++);
	// Turn of the reset, RST_N goes high
	*p_gpio_data = (*p_gpio_data & ~FALCON_MASK) | BOOT_MODE | RST_N;

	set_resp_rdy_to_input();
#endif
#ifdef XENOS
	mt_uint32 i;
	mt_uint8 chip;

	// Award modem holds only one Falcon chip
	if(chipid > MT_PORT_BroadCast)
		return MT_NO_SUCH_CHIP;

	*(falcon_port+((0x40+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	for(i=0;i<100000;i++);

	*(falcon_port+((0x20+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#ifdef HOPE
	mt_uint32 i;
	mt_uint8 chip;

	// Award modem holds only one Falcon chip
	if(chipid > MT_PORT_BroadCast)
		return MT_NO_SUCH_CHIP;

	*(falcon_port+((0x10+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	for(i=0;i<100000;i++);

	*(falcon_port+((0x20+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#if 0
//Joseph test 
	unsigned long tmp, tmp_result;
	//RALINK_GPIO_SET_DIR_OUT
	tmp = (*(volatile u32 *)(RALINK_REG_PIODIR));
	printk("3-tmp = 0x%08x\n",tmp);
	tmp |= 0x00000100;
	printk("4-tmp = 0x%08x\n",tmp);
	*(volatile u32 *)(RALINK_REG_PIODIR) = tmp;
	//write data
	tmp = (*(volatile u32 *)(RALINK_REG_PIODATA));
	printk("5-tmp = 0x%08x\n",tmp);
	tmp &=~0x00000100;
	printk("6-tmp = 0x%08x\n",tmp);
	*(volatile u32 *)(RALINK_REG_PIODATA)= tmp;
#endif

#if 0 //Joseph test def BOARD_A5
#if defined (ICPLUS_IP3210) || defined (STAR_STR9105)
	mt_uint32 i;
#endif
	//if(chipid > MT_PORT_BroadCast)
		//return MT_NO_SUCH_CHIP;
	mt_uint32 j;
#if defined (ICPLUS_IP3210)
	*databit_set = 0x1000;
	for(i=0;i<500;i++);
	*databit_clr = 0x1000;
	for(i=0;i<200000;i++);
	*databit_set = 0x1000;
#elif defined (STAR_STR9105)
	*databit_set = 0x1000;

	*databit_set = 0x2000;
	for(i=0;i<1000;i++);
	*databit_clr = 0x2000;
	for(i=0;i<1000;i++);
	*databit_set = 0x2000;
#endif	//defined (ICPLUS_IP3210)
printk("reset chip...\n");
#if 0
	RTL_W32(RTL_GPIO_PEFDIR ,(RTL_R32(RTL_GPIO_PEFDIR)  | (1<<VDSL_RESET_PIN)));//RESET pin : F[3], Dir 1 :output
	RTL_W32(RTL_GPIO_PEFDATA,(RTL_R32(RTL_GPIO_PEFDATA) | (1<<VDSL_RESET_PIN)));//RESET pin : F[3], set high
	RTL_W32(RTL_GPIO_PEFDATA,(RTL_R32(RTL_GPIO_PEFDATA) & ~(1<<VDSL_RESET_PIN)));//RESET pin : F[3], set low
	for(j=0;j<100000;j++);
	RTL_W32(RTL_GPIO_PEFDATA,(RTL_R32(RTL_GPIO_PEFDATA) | (1<<VDSL_RESET_PIN)));//RESET pin : F[3], set high
#endif

#endif

	return MT_OK;
}


mt_uint32 reset_chip_high(mt_uint32 chipid)
{
#ifdef XENOS
	mt_uint8 chip;

	*(falcon_port+((0x20+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#ifdef HOPE
	mt_uint8 chip;

	*(falcon_port+((0x20+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#ifdef BOARD_A5
	// Award modem holds only one Falcon chip
	if(chipid > MT_PORT_BroadCast)
		return MT_NO_SUCH_CHIP;

#if defined (ICPLUS_IP3210)	
	*databit_set = 0x1000;
#elif defined (STAR_STR9105)
	*databit_set = 0x2000;
#endif	//defined (ICPLUS_IP3210)

	port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif

	return MT_OK;
}


mt_uint32 reset_chip_low(mt_uint32 chipid)
{
#ifdef XENOS
	mt_uint8 chip;

	*(falcon_port+((0x40+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#ifdef HOPE
	mt_uint8 chip;

	*(falcon_port+((0x10+chipid)<<BUS_WIDTH_8_SHIFT)) = 0x0;

	if(chipid == MT_PORT_BroadCast)
	{
		for(chip = 0; chip < MAX_CHIPS; chip++)
			port_info[chip].status = MT_OPSTATE_DISABLE;
	}
	else
		port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif
#ifdef BOARD_A5
	// Award modem holds only one Falcon chip
	if(chipid > MT_PORT_BroadCast)
		return MT_NO_SUCH_CHIP;

#if defined (ICPLUS_IP3210)	
	*databit_clr = 0x1000;
#elif defined (STAR_STR9105)
	*databit_clr = 0x2000;
#endif	//defined (ICPLUS_IP3210)
	port_info[chipid].status = MT_OPSTATE_DISABLE;
#endif

	return MT_OK;
}


mt_uint8 write_hpi_8(mt_uint8 chipid, mt_uint8 data)
{
#ifdef RTL_GPIO
	mt_uint32 D_DATA_REG,E_DATA_REG;
	mt_uint32 j;
#endif
	//if(chipid > MT_PORT_BroadCast)
	//	return MT_NO_SUCH_CHIP;

#ifdef __KERNEL__
//semaphore control
	//down_interruptible(&mr_sem);
	//spin_lock(&mr_lock);
#endif

#ifdef XENOS
	*(falcon_port+(chipid<<BUS_WIDTH_8_SHIFT)) = data;
#endif
#ifdef HOPE
	*(falcon_port+(chipid<<BUS_WIDTH_8_SHIFT)) = data;
#endif
#ifdef BOARD_A5
#ifndef RTL_GPIO
	static int tmp = 0;
	if(tmp<6)
	{
		printk("%d-data = 0x%02x\n",tmp,data);	
		tmp++;
	}


	*falcon_port = data;
#else
	D_DATA_REG = 0;
	E_DATA_REG = 0;

	/*=====================================init RW CS DS value=========================*/
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_CS_PIN)));//CS pin : B[0], set high
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_DS_PIN)));//DS pin : B[1], set high
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_RW_PIN)));//RW pin : B[2], set high
	/*=================================================================================*/
	RTL_W32(RTL_GPIO_PABDIR,(RTL_R32(RTL_GPIO_PABDIR) | 0x0018000F));//ABCD(A[0:3],C[3:4]) Dir set 1 : output
	RTL_W32(RTL_GPIO_PEFDIR,(RTL_R32(RTL_GPIO_PEFDIR) | 0x00000005));//EFGH(F[0],F[2]) Dir set 1 : output
	D_DATA_REG = ((data&0x01)<<VDSL_DATA_0) | ((data&0x02)<<(VDSL_DATA_1-1)) | ((data&0x04)<<(VDSL_DATA_2-2)) | ((data&0x08)<<(VDSL_DATA_3-3)) | ((data&0x10)<<(VDSL_DATA_4-4)) | ((data&0x20)<<(VDSL_DATA_5-5));
	E_DATA_REG = ((data&0x40)<<(VDSL_DATA_6-6))  | ((data&0x80)<<(VDSL_DATA_7-7));
	RTL_W32(RTL_GPIO_PABDATA, (RTL_R32(RTL_GPIO_PABDATA) & ~(0x0018000F)) | D_DATA_REG);//write data into ABCD
	RTL_W32(RTL_GPIO_PEFDATA, (RTL_R32(RTL_GPIO_PEFDATA) & ~(0x00000005)) | E_DATA_REG);//write data into EFGH
	
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) & ~(1<<VDSL_CS_PIN)));//CS pin set low
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) & ~(1<<VDSL_DS_PIN)));//DS pin set low

	for(j=0;j<1200;j++);// 1200:6.25 micro seconds

	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_DS_PIN)));//DS pin set high
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_CS_PIN)));//CS pin set high

//printk("0x%08x 0x%08x \n", D_DATA_REG, E_DATA_REG);


#endif
#endif
#ifdef AWARD
	*(mt_uint8*) FALCON_PORT = data;
#endif

#ifdef __KERNEL__
//semaphore control
	//up(&mr_sem);
	//spin_unlock(&mr_lock);
#endif

	return MT_OK;
}

mt_uint8 read_hpi_8(mt_uint8 chipid)
{
	mt_uint8 retval;
#ifdef RTL_GPIO
	mt_uint32 D_DATA_REG=0;
	mt_uint32 E_DATA_REG=0;
	mt_uint32 j;
#endif
/*#ifdef BOARD_A5
	volatile mt_uint32 *addr;
#endif*/

	//if(chipid > MT_PORT_BroadCast)
	//	return MT_NO_SUCH_CHIP;

#ifdef __KERNEL__
//semaphore control
	//down_interruptible(&mr_sem);
	//spin_lock(&mr_lock);
#endif

#ifdef XENOS
	retval = *(falcon_port+(chipid<<BUS_WIDTH_8_SHIFT));
#endif
#ifdef HOPE
	retval = *(falcon_port+(chipid<<BUS_WIDTH_8_SHIFT));
#endif
#ifdef BOARD_A5
	/*(volatile void *)addr = ioremap(FALCON_PORT, 0x2);
	retval = *(volatile mt_uint8 *)addr;
	iounmap((void *)addr);*/
#ifndef RTL_GPIO
	retval = *falcon_port;
#else
	/*=====================================init RW CS DS value=========================*/
	RTL_W32(RTL_GPIO_PABDIR,(RTL_R32(RTL_GPIO_PABDIR) & ~(0x0018000F)));//ABCD(A[0:3],C[3:4]) Dir set 0 : input
	RTL_W32(RTL_GPIO_PEFDIR,(RTL_R32(RTL_GPIO_PEFDIR) & ~(0x00000005)));//EFGH(F[0],F[2]) Dir set 0 : input
	
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_RW_PIN)));//RW pin set high
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_CS_PIN)));//CS pin set high
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_DS_PIN)));//DS pin set high
	/*=================================================================================*/
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) & ~(1<<VDSL_CS_PIN)));//CS pin set low
	for(j=0;j<5000;j++);//original 5000,26 micro seconds
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) & ~(1<<VDSL_RW_PIN)));//RW pin set low
	for(j=0;j<1000;j++);//1000,5.2 micro seconds
	D_DATA_REG = RTL_R32(RTL_GPIO_PABDATA);
	E_DATA_REG = RTL_R32(RTL_GPIO_PEFDATA);
	
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_RW_PIN)));//RW pin set high
	for(j=0;j<5000;j++);//5000,26 micro seconds
	RTL_W32(RTL_GPIO_PABDATA,(RTL_R32(RTL_GPIO_PABDATA) | (1<<VDSL_CS_PIN)));//CS pin set high
	retval = ((D_DATA_REG>>VDSL_DATA_0)&0x0F) | (((D_DATA_REG>>VDSL_DATA_4)&0x03)<<4) | (((E_DATA_REG>>VDSL_DATA_6)&0x01)<<6) | (((E_DATA_REG>>VDSL_DATA_7)&0x01)<<7);
	//RTL_W32(RTL_GPIO_PEFDATA,(RTL_R32(RTL_GPIO_PEFDATA) & ~(0x00000010)));//DS pin set low
	//printk(" 0x%02x \n",retval);
	//printk("ABDIR: 0x%08x EFDIR: 0x%08x \n", RTL_R32(RTL_GPIO_PABDIR), RTL_R32(RTL_GPIO_PEFDIR));
#endif
#endif
#ifdef AWARD
	retval = *(mt_uint8*) FALCON_PORT;
#endif

#ifdef __KERNEL__
//semaphore control
	//up(&mr_sem);
	//spin_unlock(&mr_lock);
#endif

	return retval;
}


mt_uint32 default_gpio_a3(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_en = (mt_uint32*) GPIO_EN;
	volatile mt_uint32* p_gpio_ben = (mt_uint32*) GPIO_BEN;
	volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	//volatile mt_uint32* p_gpio_data = (mt_uint32*) GPIO_DATA;
	//mt_uint32 gpio_value;

	*p_gpio_en = 0x5F008FFF  ;
	*p_gpio_dir = 0x5A008FFF ; 
	*p_gpio_ben = 0x5F008FFF ;
    
	PRINTD("default_gpio_a3\n");
    //*p_gpio_data &= 0x00000000 ;

	//gpio_value = *p_gpio_data;
	//PRINTD("gpio_value=%x\n",gpio_value & 0x00005400);
#endif
	return MT_OK;
	//*p_gpio_data |= 0x00000100;	
}


mt_uint32 default_gpio_a2(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_en = (mt_uint32*) GPIO_EN;
	volatile mt_uint32* p_gpio_ben = (mt_uint32*) GPIO_BEN;
	volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	//volatile mt_uint32* p_gpio_data = (mt_uint32*) GPIO_DATA;
	//mt_uint32 gpio_value;
        
	*p_gpio_en = *p_gpio_en | 0x000000f0;
	*p_gpio_dir = *p_gpio_dir | 0x000000f0;
	*p_gpio_ben = *p_gpio_ben | 0x000000f0;	

	PRINTD("default_gpio_a2\n");
#endif
	return MT_OK;
}


mt_uint32 init_system_board(void)
{
#ifdef AWARD
	mt_uint32 tmp = *(mt_uint32*)EBI_BCR2;	
	
	// Set Default GPIO
	default_gpio();	
	
	// Setup Ready PIN
	SETRDYPIN();	

	PRINTL(DBG_LVL_BOARD,"EBI_BCR2 before change %x\n", tmp);
	// For now we are changing only BUSMODE, RDY polarity and BW
	// BM = Motorola with RDY, BW 8-bit, RDY polarity - active high
	tmp &= 0xffffffa0;
	tmp |= /*BUSMODE*/ 5 | /*BW*/ 0 | /*RDY pol*/ 0x40;
	*(mt_uint32*)EBI_BCR2 = tmp;
	PRINTL(DBG_LVL_BOARD,"EBI_BCR2 after change %x\n", tmp);

	set_resp_rdy_to_input();
#endif
	return MT_OK;
}


/**
 * Set RDY Pin to GPIO26, used in V3
 */
void set_rdy_pin(void)
{
	mt_uint32 tmp = *(mt_uint32*)EBI_BCR2;	

	// Modify RDY to GPIO26
	tmp = *(mt_uint32*)EBI_RDY;
	tmp &= 0xf000ffff;
	tmp |= 0x04000000;
	*(mt_uint32*)EBI_RDY = tmp;		
}


mt_uint32 get_max_chips(void)
{
	return MAX_CHIPS;
}


mt_uint32 check_response_rdy(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_data = (mt_uint32*) GPIO_DATA;
#else
	volatile mt_uint32* p_gpio_data = RTL_R32(RTL_GPIO_PEFDATA);
#endif
 	return *p_gpio_data & RESP_RDY_BIT;	
}


void set_irqa_to_input(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	*p_gpio_dir = (*p_gpio_dir & ~IRQA_BIT);
#endif
}


void set_irqa_to_output(void)
{
#ifndef RTL_GPIO
	volatile mt_uint32* p_gpio_dir = (mt_uint32*) GPIO_DIR;
	*p_gpio_dir |= IRQA_BIT;
#endif
}


void trigger_irq(void)
{
#if defined (AWARD)
	volatile mt_uint32* p_gpio_data = (mt_uint32*) GPIO_DATA;
	
	*p_gpio_data = (*p_gpio_data & ~IRQA_BIT);
	*p_gpio_data = (*p_gpio_data | IRQA_BIT);
#elif defined (STAR_STR9105)
	*databit_clr = 0x1000;
	*databit_set = 0x1000;
#endif
}
