/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009/03/18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"

#define HOST_MSG_ADDR 0x12
#define HOST_MSG_CTRL 0x12

mt_ret snmp_dsp_set (mt_uint32 portid, mt_uint32 groupid, mt_uint32 tableid,
					   mt_uint32 idx, mt_uint32 paramid, mt_uint32 value)
{
	mt_uint8 cbuf[20];

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;
	
	/*if( groupid > MT_MIB_VdslMetanoiaGroup || groupid < MT_MIB_VdslGroup )
	{
		PRINTL(DBG_LVL_SNMPT,"Unsupported groupid - %i\n",groupid);
		return DSL_ERR_NOTOK;
	}*/

	PRINTL(DBG_LVL_SNMPT,"in snmp_dsp_set: start\n");	

	cbuf[3] = 0x14 | idx;
	cbuf[4] = (groupid << 4) | tableid;
	cbuf[5] = paramid-1;
	cbuf[6] = 1;
	cbuf[7] = value >> 16;
	cbuf[8] = (value >> 8) & 0xff;
	cbuf[9] = value & 0xff;
	return send_frame_port(portid, 10, cbuf);
}

mt_ret snmp_dsp_get (mt_uint32 portid, mt_uint32 groupid, mt_uint32 tableid,
					   mt_uint32 idx, mt_uint32 paramid,mt_uint32 *pvalue)
{
	mt_ret ret;
	mt_uint8 cbuf[20];

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;

	/*if( groupid > MT_MIB_VdslMetanoiaGroup || groupid < MT_MIB_VdslGroup )
	{
		PRINTL(DBG_LVL_SNMPT,"Unsupported groupid - %i\n",groupid);
		return DSL_ERR_NOTOK;
	}*/
	
	PRINTL(DBG_LVL_SNMPT,"in snmp_dsp_get: start\n");	

	cbuf[3] = 0x10 | idx;
	cbuf[4] = (groupid << 4) | tableid;
	cbuf[5] = paramid-1;
	cbuf[6] = 1;
	ret = send_frame_port(portid, 7, cbuf);

	PRINTL(DBG_LVL_SNMPT,"in snmp_dsp_get: return=%i\n",ret);

	//while(!port_resp_rdy(portid));
	*pvalue = get_port_value(portid);
	
	return ret;
}
