#include "unilog.h"

#ifdef EXTRA_MSG_DEBUG
#define DEBUG(args...) LPRINTF(PRI_I, args);
#else
#define DEBUG(args...)
#endif

/*
	interface, The interface. ex eth0
	index, wan index. ex 1 wan1 ; 2 wan2 ...

Output success or fail (1 or 0)
*/
int trafficCompare (char *interface, int index);

/*
	destif , The interface
	destip , The ip you ping
	recv_sec,  Second you want to wait
	recv_usec, Millisecond
Output success or fail (1 or 0) 
*/
int send_icmp (const char *destif, const char *destip,unsigned int recv_sec,unsigned int recv_usec);

/*
	host , The name you want to query.  ex  www.google.com
	destif , The interface. ex eth0
	index , 1 represent The DNS server which is the first founded in your computer.
		   Ohters interger except 1 is The second DNS server
Output, success or fail (>=1 or 0)
*/
int dns_query(unsigned char *host,const char *destif,int index);

/*
	dns: The name is  which you want to query. ex www.google.com.tw
	interface: The interface is the interface.
	ping_ip: The ping_ip is  which you ping

Output: success or fail (1 or 0)
*/
int keepalivelib(char *dns, char *interface, char* ping_ip);
